Update __DragonFly_version as well. Don't let this slip, please.
[dragonfly.git] / crypto / openssh-3.9p1 / regress / multiplex.sh
1 #       $OpenBSD: multiplex.sh,v 1.8 2004/06/22 03:12:13 markus Exp $
2 #       Placed in the Public Domain.
3
4 CTL=$OBJ/ctl-sock
5
6 tid="connection multiplexing"
7
8 DATA=/bin/ls${EXEEXT}
9 COPY=$OBJ/ls.copy
10
11 start_sshd
12
13 trace "start master, fork to background"
14 ${SSH} -2 -MS$CTL -F $OBJ/ssh_config -oSendEnv="_XXX_TEST" -f somehost sleep 120
15
16 verbose "test $tid: envpass"
17 trace "env passing over multiplexed connection"
18 _XXX_TEST=blah ${SSH} -oSendEnv="_XXX_TEST" -S$CTL otherhost sh << 'EOF'
19         test X"$_XXX_TEST" = X"blah"
20 EOF
21 if [ $? -ne 0 ]; then
22         fail "environment not found"
23 fi
24
25 verbose "test $tid: transfer"
26 rm -f ${COPY}
27 trace "ssh transfer over multiplexed connection and check result"
28 ${SSH} -S$CTL otherhost cat ${DATA} > ${COPY}
29 test -f ${COPY}                 || fail "ssh -Sctl: failed copy ${DATA}" 
30 cmp ${DATA} ${COPY}             || fail "ssh -Sctl: corrupted copy of ${DATA}"
31
32 rm -f ${COPY}
33 trace "ssh transfer over multiplexed connection and check result"
34 ${SSH} -S $CTL otherhost cat ${DATA} > ${COPY}
35 test -f ${COPY}                 || fail "ssh -S ctl: failed copy ${DATA}" 
36 cmp ${DATA} ${COPY}             || fail "ssh -S ctl: corrupted copy of ${DATA}"
37
38 rm -f ${COPY}
39 trace "sftp transfer over multiplexed connection and check result"
40 echo "get ${DATA} ${COPY}" | \
41         ${SFTP} -S ${SSH} -oControlPath=$CTL otherhost >/dev/null 2>&1
42 test -f ${COPY}                 || fail "sftp: failed copy ${DATA}" 
43 cmp ${DATA} ${COPY}             || fail "sftp: corrupted copy of ${DATA}"
44
45 rm -f ${COPY}
46 trace "scp transfer over multiplexed connection and check result"
47 ${SCP} -S ${SSH} -oControlPath=$CTL otherhost:${DATA} ${COPY} >/dev/null 2>&1
48 test -f ${COPY}                 || fail "scp: failed copy ${DATA}" 
49 cmp ${DATA} ${COPY}             || fail "scp: corrupted copy of ${DATA}"
50
51 rm -f ${COPY}
52
53 for s in 0 1 4 5 44; do
54         trace "exit status $s over multiplexed connection"
55         verbose "test $tid: status $s"
56         ${SSH} -S $CTL otherhost exit $s
57         r=$?
58         if [ $r -ne $s ]; then
59                 fail "exit code mismatch for protocol $p: $r != $s"
60         fi
61
62         # same with early close of stdout/err
63         trace "exit status $s with early close over multiplexed connection"
64         ${SSH} -S $CTL -n otherhost \
65                 exec sh -c \'"sleep 2; exec > /dev/null 2>&1; sleep 3; exit $s"\'
66         r=$?
67         if [ $r -ne $s ]; then
68                 fail "exit code (with sleep) mismatch for protocol $p: $r != $s"
69         fi
70 done
71
72 # kill master, remove control socket.  ssh -MS will exit when sleep exits
73 $SUDO kill `cat $PIDFILE`
74 rm -f $CTL